///////////////////////////////////////////////////////////////////////////////
//ǽå˥Ϥ롣
//⡧Windows,UNIX ǥͭ
//Copyright (C) 2001-2002 Takashi Sugiyama. All rights reserved.
///////////////////////////////////////////////////////////////////////////////
#include "TSLog.h"
#include <stdio.h>
#include <stdlib.h> //atoi(),_splitpath(),calloc()
#include <memory.h> //memset()
#include <string.h> //memset()
#include <malloc.h> //calloc()
#include <time.h> //time()
#include <errno.h> //EACCES
#include "TSCSV.h"
#ifdef WIN32
	#include <direct.h> //_mkdir()
	#include <mbstring.h> //_mbsstr()
	#define MBSICMP(a,b) _mbsicmp(a,b) //ʸʸ̤ʤ
	#define MBSSTR(a,b) _mbsstr(a,b)
	#define ISMBSLEAD(a,b) _ismbslead(a,b)
	#define WaitForSingleObjectSafety(Mtx,TimeOut) \
			if ( 1 ) \
			{ \
				if ( Mtx ) \
					WaitForSingleObject( Mtx, TimeOut ); \
			} else
	#define ReleaseMutexSafety(Mtx) \
			if ( 1 ) \
			{ \
				if ( Mtx ) \
					ReleaseMutex( Mtx ); \
			} else
#else //UNIX
	#include <sys/types.h> //semget()
	#include <sys/ipc.h> //semget()
	#include <sys/sem.h> //semget()
	#include <ctype.h> //isprint()
	#include <stdarg.h> //varargs.h Ȥ .cpp ϥѥܤ va_alist 򤹤
	#include "TSMBS.h"
	#define MBSICMP(a,b) strcasecmp(a,b)
	#define MBSSTR(a,b) TSC_mbsstr(a,b)
	#define ISMBSLEAD(a,b) TSC_ismbslead(a,b)

	#define _MAX_DRIVE 4
	#define _MAX_PATH 256
	#define CONST const
	#define FALSE 0
	#define TRUE 1
	typedef void VOID;
	typedef void* LPVOID;
	typedef int BOOL;
	typedef int* LPBOOL;
	typedef int INT;
	typedef int* LPINT;
	typedef long LONG;
	typedef long* LPLONG;
	typedef unsigned long DWORD;
	typedef unsigned long* LPDWORD;
	typedef char TCHAR;
	typedef char* LPTSTR;
	typedef const char* LPCTSTR;
	typedef unsigned char BYTE;
	typedef unsigned char* LPBYTE;
#endif

#define ERRNO_4201 4201 //TSCSV_GetID()
						//V1.0.0
#define ERRNO_4202 4202 //TSCSV_SetDelimiter()
						//V1.0.0
#define ERRNO_4203 4203 //TSCSV_SetQuot()
						//V1.0.0
#define ERRNO_4204 4204 //calloc()
						//V1.0.0
#define ERRNO_4205 4205 //ID Ĥʤ
						//V1.0.0 
#define ERRNO_4206 4206 //GetModuleFileName()
						//V1.0.0
#define ERRNO_4207 4207 //إå
						//V1.0.0 
#define ERRNO_4208 4208 //GetModuleFileName()
						//V1.0.0
#define ERRNO_4209 4209 //ե̾ (UNIX)
						//V1.0.0 
#define ERRNO_4210 4210 //freopen()
						//V1.0.0
#define ERRNO_4211 4211 //ե򥪡ץǤʤ
						//V1.0.0 
//#define ERRNO_4212 4212 //
						//
//#define ERRNO_4213 4213 //
						//

#define LOG_LENGTH_MAX 256 //Ĺ

struct ID_INFO //ID
{
	INT iID; //ID
	LPTSTR pszLogDir; //ϥե̾
	INT iCSV_Item; //TSCSV  IDʹܼѡǥߥ ';'
	INT iCSV_Val; //TSCSV  IDʥͼѡǥߥ '='
	INT iSemKey; //ޥեTSLogSem ˤäƥޥեƺ뤳Ȥθ
                 //SemID ¸ʤ
	INT iErrNo; //顼
#ifdef WIN32
	HANDLE hMtx; //¾ʥեѡ
#endif
	struct ID_INFO *ps_IDNext; //ι¤ΤؤΥݥ
};

struct LOG_HEADER_INFO //إå
{
	BOOL bTime; //TRUE:ॹפ
	BOOL bStdOut; //TRUE:ɸϤˤϤ
	BOOL bOverWrit; //FALSE:ɲ  TRUE:Ƭ
	INT iLvl; //ϥ٥  2:WriteLog2()   3:WriteLog2()  WriteLog3() 
	BOOL bHex; //TRUE:TSLOG_WriteLogHex() Ϥ
	BOOL bCut; //TRUE:Ԥ˼ޤʤڤΤƤ
	TCHAR cCRLF; //ԥɤɽʸ
	DWORD dwLogLen; //Ĺʲԥʬޤޤʤ
	DWORD dwLogCntMax; //
	DWORD dwLogCnt; //¸Υʥǥå
	BOOL bInit; //TRUE:Υƥꥢ
};

static BOOL mbInit = FALSE; //=FALSE:̤  =TRUE:Ѥ
static INT miErrNo = 0; //顼
static struct ID_INFO ms_IDTop; //Ƭ
static TCHAR mszMtx[_MAX_PATH+1] = { 0 }; //󥯸¹ԥե Mutex 

#ifndef WIN32
///////////////////////////////////////////////////////////////////////////////
//ǽޥեå롣
//ֵ͡=0:ｪλ  <0:顼
//СV1.0.0 2002/01/27 
///////////////////////////////////////////////////////////////////////////////
static int SemaphoreLock(
int iSemKey
)
{
	int iSemID = 0;
	struct sembuf s_SemBuf;

//
	memset( &s_SemBuf, 0, sizeof( s_SemBuf ));
//ᥤ
	if ( !iSemKey ) //ʤ
		return 0;
	iSemID = semget( iSemKey,1, IPC_CREAT|IPC_EXCL|0666 );
	if ( iSemID != -1 ) //˺
		semctl( iSemID, 0, SETVAL, 1 ); //򥻥å
	else //¸ߤƤ
		iSemID = semget( iSemKey, 1, IPC_CREAT|0666 ); //å
	if ( iSemID != -1 )
	{
		s_SemBuf.sem_op = -1; //ˤ
		semop( iSemID, &s_SemBuf, 1 );
	}
	return 0;
}

///////////////////////////////////////////////////////////////////////////////
//ǽޥե򥢥å롣
//ֵ͡=0:ｪλ  <0:顼
//СV1.0.0 2002/01/27 
///////////////////////////////////////////////////////////////////////////////
static int SemaphoreUnlock(
int iSemKey
)
{
	int iSemID = 0;
	struct sembuf s_SemBuf;

//
	memset( &s_SemBuf, 0, sizeof( s_SemBuf ));
//ᥤ
	if ( !iSemKey ) //ʤ
		return 0;
	iSemID = semget( iSemKey,1, IPC_CREAT|IPC_EXCL|0666 );
	if ( iSemID == -1 ) //¸ߤƤ
	{
		iSemID = semget( iSemKey, 1, IPC_CREAT|0666 ); //å
		if ( iSemID != -1 )
		{
			s_SemBuf.sem_op = 1; //ˤ
			semop( iSemID, &s_SemBuf, 1 );
		}
	}
	else //äƤޤä顢ΤϤ
		;
	return 0;
}
#endif

///////////////////////////////////////////////////////////////////////////////
//ǽTSCSV 򥻥åȤ롣
//ֵ͡=0:ｪλ  <0:顼
//СV1.0.0 2002/01/02 
///////////////////////////////////////////////////////////////////////////////
static INT SetTSCSV(
LPCTSTR pszDlmt, //(I)ǥߥ
LPINT piCSVID //(O)TSCSV  ID
)
{
	INT iCSVID = 0;
//
	*piCSVID = 0;
//ᥤ
	iCSVID = TSCSV_GetID(); //ID 
	if ( iCSVID < 0 )
	{	//顼
		miErrNo = ERRNO_4201;
		return -1;
	}
	if ( TSCSV_SetDelimiter( iCSVID, pszDlmt ) < 0 ) //ǥߥ򥻥å
	{
		TSCSV_FreeID( iCSVID );
		miErrNo = ERRNO_4202;
		return -1;
	}
	if ( TSCSV_SetQuot( iCSVID, NULL ) < 0 ) //ʸ̵
	{
		TSCSV_FreeID( iCSVID );
		miErrNo = ERRNO_4203;
		return -1;
	}
	*piCSVID = iCSVID;
	return 0;
}

/////////////////////////////////////////////////////////////////////////////
//ǽʸαߥޡ򥹥åѴ롣
//ֵ͡=0:ｪλ  <0:顼
//СV1.0.0 2002/01/14 
/////////////////////////////////////////////////////////////////////////////
static INT ConvertYen(
LPTSTR pszStr
)
{
	LPTSTR pszNext = NULL;

	pszNext = pszStr;
	while ( 1 ) //ߥޡѴ Mutex ˻ѤǤʤ
	{
		pszNext = MBSSTR( pszNext, "\\" );
		if ( !pszNext ) //ߥޡĤʤʤ
			break;
		*pszNext = '/'; //åѴ
		pszNext++;
	}
	return 0;
}

/////////////////////////////////////////////////////////////////////////////
//ǽID ˳ ID_INFO 롣
//ֵ͡!=0:ID_INFO Υݥ  =0:ID Ĥʤ
//СV1.0.0 2001/11/01 
/////////////////////////////////////////////////////////////////////////////
static struct ID_INFO *GetIDInfo(
CONST INT iID, //(I)ID >0
struct ID_INFO **pps_IDPrev //(O) ID_INFO ľ ID_INFO
)
{
	struct ID_INFO *ps_IDTmp = NULL, *ps_IDPrev = NULL;
#ifdef WIN32
	HANDLE hMtx = CreateMutex( NULL, FALSE, mszMtx );
	WaitForSingleObjectSafety( hMtx, INFINITE ); //å
#endif
	ps_IDTmp = ms_IDTop.ps_IDNext; // ID õ
	ps_IDPrev = &ms_IDTop;
	while ( ps_IDTmp )
	{
		if ( ps_IDTmp->iID == iID ) ///ID פ
			break;
		ps_IDPrev = ps_IDTmp; //ҤȤȤ¸
		ps_IDTmp = ps_IDTmp->ps_IDNext;
	}
	if ( pps_IDPrev )
		*pps_IDPrev = ps_IDPrev;
	if ( !ps_IDTmp )
	{	//顼
		miErrNo = ERRNO_4205;
#ifdef WIN32
		ReleaseMutexSafety( hMtx ); //å
#endif
		return 0;
	}
#ifdef WIN32
	ReleaseMutexSafety( hMtx ); //å
#endif //WIN32
	return ps_IDTmp;
}

///////////////////////////////////////////////////////////////////////////////
//ǽ롣
//å¾椹ΤŪŵư줿Ȥˤ¾Ƥ
//      Τϻʤ
//ֵ͡=0:ｪλ  =1:Ѥ  <0:顼
//СV1.0.0 2002/01/14 
///////////////////////////////////////////////////////////////////////////////
static INT Init()
{
	INT iRet = 0;
	TCHAR szExeDir[_MAX_PATH+1] = { 0 };
//ᥤ
#ifdef WIN32
	HANDLE hMtx = NULL;

	//DLL ƤӽФȤμ¹ԥե̾
	if ( !GetModuleFileName( NULL, szExeDir, sizeof( szExeDir )))
	{
		miErrNo = ERRNO_4206;
		return -1;
	}
	ConvertYen( szExeDir ); //ߥޡѴ Mutex ǤϻѤǤʤ
	hMtx = CreateMutex( NULL, FALSE, szExeDir ); //
	WaitForSingleObjectSafety( hMtx, INFINITE ); //å
#endif //WIN32
	if ( mbInit ) //Ѥߤʤ
		iRet = 1;
	else
	{
// DLL θƤӽФȼ¹ԥեΥ󥹥ˣ¹Ԥ롣
//åˤϼ¹Ԥʤ
		memset( &ms_IDTop, 0, sizeof( ms_IDTop ));
		strcpy( mszMtx, szExeDir );
		mbInit = TRUE; //Ѥߥե饰
		iRet = 0;
	}
#ifdef WIN32
	ReleaseMutexSafety( hMtx ); //å
#endif //WIN32
	return iRet;
}

///////////////////////////////////////////////////////////////////////////////
//ǽID롣
//ֵ͡>0:ID  <0:顼
//СV1.0.0 2002/01/01 
///////////////////////////////////////////////////////////////////////////////
INT WINAPI TSLOG_GetID()
{
	INT iMaxID = 0; //ȯԺѤIDκ
	struct ID_INFO *ps_IDNew = NULL, *ps_IDTmp = NULL;
#ifdef WIN32
	HANDLE hMtx = NULL;
#endif
//ᥤ
	if ( Init() < 0 ) //
		return -1;
#ifdef WIN32
	hMtx = CreateMutex( NULL, FALSE, mszMtx );
	WaitForSingleObjectSafety( hMtx, INFINITE ); //å
#endif
	ps_IDTmp = &ms_IDTop; //ǽݥ󥿤õ
	while ( ps_IDTmp->ps_IDNext )
	{
		ps_IDTmp = ps_IDTmp->ps_IDNext;
		if ( ps_IDTmp->iID > iMaxID ) //IDκͤõʤ
			iMaxID = ps_IDTmp->iID;
	}
	ps_IDNew = (struct ID_INFO*)calloc( 1, sizeof( struct ID_INFO ));
	if ( !ps_IDNew )
	{
		miErrNo = ERRNO_4204;
#ifdef WIN32
		ReleaseMutexSafety( hMtx ); //å
#endif
		return -1;
	}
	ps_IDNew->iID = iMaxID+1; //ID򥻥å
	if ( SetTSCSV( ",", &ps_IDNew->iCSV_Item ) < 0 ) //ܼ
	{
		free( ps_IDNew );
#ifdef WIN32
		ReleaseMutexSafety( hMtx ); //å
#endif
		return -1;
	}
	if ( SetTSCSV( "=", &ps_IDNew->iCSV_Val ) < 0 ) //ͼ
	{
		free( ps_IDNew );
#ifdef WIN32
		ReleaseMutexSafety( hMtx ); //å
#endif
		return -1;
	}
	ps_IDTmp->ps_IDNext = ps_IDNew; //κǸɲ
#ifdef WIN32
	ReleaseMutexSafety( hMtx ); //å
#endif
	return ps_IDNew->iID;
}

/////////////////////////////////////////////////////////////////////////////
//ǽե뤫إåɤ߹ࡣ
//ֵ͡=0:ｪλ  <0:顼
//СV1.0.0 2002/01/01 
/////////////////////////////////////////////////////////////////////////////
static INT ReadHeader(
struct ID_INFO *ps_ID, //(I)ID
FILE *fp, //(I/O)ե뼱̻
struct LOG_HEADER_INFO *ps_lghHdr //(O)إå
)
{
	BOOL bHdrErr = FALSE; //顼ե饰
	TCHAR szHdr[LOG_LENGTH_MAX] = { 0 }, szKey[8] = { 0 }, szVal[LOG_LENGTH_MAX] = { 0 };
	TCHAR szTmp[LOG_LENGTH_MAX] = { 0 };
	INT iCnt = 0, i = 0;
//
	memset( ps_lghHdr, 0, sizeof( *ps_lghHdr ));
	//ǥեͤ򥻥å
	ps_lghHdr->bTime = 1;
	ps_lghHdr->bStdOut = 0;
	ps_lghHdr->bOverWrit = 1;
	ps_lghHdr->iLvl = 1;
	ps_lghHdr->bHex = 1;
	ps_lghHdr->bCut = 0;
	ps_lghHdr->cCRLF = '|';
	ps_lghHdr->dwLogCntMax = 1000;
	ps_lghHdr->dwLogCnt = 0;
	ps_lghHdr->bInit = 0;
//ᥤ
	fseek( fp, 0, SEEK_SET ); //Ƭذư
	fgets( szHdr, sizeof( szHdr ), fp ); //إåɤ߹
	iCnt = TSCSV_GetFieldCount( ps_ID->iCSV_Item, szHdr ); //եɿ
	if ( iCnt < 0 )
	{
		ps_ID->iErrNo = ERRNO_4207;
		return -1;
	}
	for ( i = 0 ; i < iCnt ; i++ )
	{	//ܤ
		if ( TSCSV_GetFieldAsString( ps_ID->iCSV_Item, szHdr, i, szTmp, sizeof( szTmp )) < 0 )
		{
			ps_ID->iErrNo = ERRNO_4207;
			return -1;
		}
		//
		if ( TSCSV_GetFieldAsString( ps_ID->iCSV_Val, szTmp, 0, szKey, sizeof( szKey )) < 0 )
		{
			ps_ID->iErrNo = ERRNO_4207;
			return -1;
		}
		//ͤ
		if ( TSCSV_GetFieldAsString( ps_ID->iCSV_Val, szTmp, 1, szVal, sizeof( szVal )) < 0 )
		{
			ps_ID->iErrNo = ERRNO_4207;
			return -1;
		}
		if ( !MBSICMP( szKey, "Time" )) //ॹ
			ps_lghHdr->bTime = ( atoi( szVal )) ? TRUE : FALSE;
		else if ( !MBSICMP( szKey, "StdO" )) //ɸ
			ps_lghHdr->bStdOut = ( atoi( szVal )) ? TRUE : FALSE;
		else if ( !MBSICMP( szKey, "OverW" )) //
			ps_lghHdr->bOverWrit = ( atoi( szVal )) ? TRUE : FALSE;
		else if ( !MBSICMP( szKey, "Lvl" )) //ϥ٥
			ps_lghHdr->iLvl = atoi( szVal );
		else if ( !MBSICMP( szKey, "Hex" )) //hex
			ps_lghHdr->bHex = ( atoi( szVal )) ? TRUE : FALSE;
		else if ( !MBSICMP( szKey, "Cut" )) //ڤΤ
			ps_lghHdr->bCut = ( atoi( szVal )) ? TRUE : FALSE;
		else if ( !MBSICMP( szKey, "CR" )) //ԥ
			ps_lghHdr->cCRLF = szVal[0];
		else if ( !MBSICMP( szKey, "Len" )) //1Ĺ
			ps_lghHdr->dwLogLen = atol( szVal );
		else if ( !MBSICMP( szKey, "Max" )) //
			ps_lghHdr->dwLogCntMax = atol( szVal );
		else if ( !MBSICMP( szKey, "Cnt" )) //ߤη
			ps_lghHdr->dwLogCnt = atol( szVal );
		else if ( !MBSICMP( szKey, "Init" )) //
			ps_lghHdr->bInit = ( atoi( szVal )) ? TRUE : FALSE;
	}
	if ( ps_lghHdr->dwLogLen < 79 )
		ps_lghHdr->dwLogLen = 79;
	return 0;
}

/////////////////////////////////////////////////////////////////////////////
//ǽե򳫤
//ֵ͡=0:ｪλ  <0:顼
//СV1.0.0 2001/12/03 
/////////////////////////////////////////////////////////////////////////////
static INT OpenLog(
struct ID_INFO *ps_ID, //(I)ID
FILE **pfp, //(O)ե뼱̻
struct LOG_HEADER_INFO *ps_lghHdr //(O)إå
)
{
	FILE *fp = NULL;
//
	*pfp = NULL;
	memset( ps_lghHdr, 0, sizeof( *ps_lghHdr ));
//ᥤ
	fp = fopen( ps_ID->pszLogDir, "r+" );
	if ( !fp )
	{
		ps_ID->iErrNo = ERRNO_4211;
		return -1;
	}
//	setvbuf( fp, NULL, _IONBF, 0 );
	if ( ReadHeader( ps_ID, fp, ps_lghHdr ) < 0 ) //إå
		return -1;
	*pfp = fp;
	return 0;
}

/////////////////////////////////////////////////////////////////////////////
//ǽĹĴ᤹롣
//ֵ͡=1:ޤ꤭ʤä
//        =2:ޤ꤭줺Хʸڤʤ褦
//        =0:ޤä
//        <0:顼
//СV1.0.0 2002/01/01 
/////////////////////////////////////////////////////////////////////////////
static INT MakeSameLength(
struct ID_INFO *ps_ID, //(I)ID
LPCTSTR pszLog, //(I)
CONST DWORD dwAftrLen, //(I)ĴΥĹ'\n'ޤޤʤ
CONST TCHAR cCRLF, //(I)'\n' ɽʸ
LPTSTR pszOutLog //(O)ѡ dwAftrLen+'\n'+'\0' ʬΥɬס
)
{
	INT iRet = 0;
	LPTSTR pszNext = NULL;
	DWORD dwLogLen = 0;
//
	memset( pszOutLog, 0, dwAftrLen+2 ); //+2:'\n'+'\0'
//ᥤ
	//СեβǽΤǡ strcpy( pszOutLog, pszLog ) ϤǤʤ
	dwLogLen = strlen( pszLog );
	if ( dwLogLen <= dwAftrLen ) //ꤷĹûƱʤ
	{
		strcpy( pszOutLog, pszLog );
		memset( &pszOutLog[dwLogLen], ' ', dwAftrLen-dwLogLen ); //ڡѥǥ
	}
	else if ( dwLogLen > dwAftrLen ) //ޤ꤭ʤä
	{
		if ( ISMBSLEAD( pszLog, pszLog+dwAftrLen-1 ) == -1 ) //ԥХȤʤ
		{
			strncpy( pszOutLog, pszLog, dwAftrLen-1 );
			strcat( pszOutLog, " " );
			iRet = 2;
		}
		else
		{
			strncpy( pszOutLog, pszLog, dwAftrLen );
			iRet = 1;
		}
	}
	pszNext = pszOutLog;
	while ( 1 )
	{
		pszNext = (LPTSTR)MBSSTR((LPBYTE)pszNext, (LPBYTE)"\n" ); //ԥɤ򸡺
		if ( !pszNext )
			break;
		*pszNext = cCRLF;
	}
	strcat((LPBYTE)pszOutLog, (LPBYTE)"\n" );
	return iRet;
}

/////////////////////////////////////////////////////////////////////////////
//ǽե˥إå񤭹ࡣ
//ֵ͡=0:ｪλ  <0:顼
//СV1.0.0 2002/01/02 
/////////////////////////////////////////////////////////////////////////////
static INT WriteHeader(
struct ID_INFO *ps_ID, //(I)ID
FILE *fp, //(I/O)ե
CONST struct LOG_HEADER_INFO *ps_lghHdr //(I)إå
)
{
	TCHAR szHdr[LOG_LENGTH_MAX] = { 0 }, szOutHdr[LOG_LENGTH_MAX] = { 0 };

	sprintf( szHdr, "Time=%d,StdO=%d,OverW=%d,Lvl=%d,Hex=%d,Cut=%d,CR=%c,Len=%d,Max=%d,Cnt=%d,Init=%d",
			ps_lghHdr->bTime, ps_lghHdr->bStdOut, ps_lghHdr->bOverWrit,
			ps_lghHdr->iLvl, ps_lghHdr->bHex,
			ps_lghHdr->bCut, ps_lghHdr->cCRLF,
			ps_lghHdr->dwLogLen, ps_lghHdr->dwLogCntMax, ps_lghHdr->dwLogCnt,
			ps_lghHdr->bInit );
	if ( MakeSameLength( ps_ID, szHdr, ps_lghHdr->dwLogLen, '|', szOutHdr )) //ĹĴ
		return -1;
	fseek( fp, 0, SEEK_SET );
	fputs( szOutHdr, fp );
	fflush( fp );
	return 0;
}

/////////////////////////////////////////////////////////////////////////////
//ǽե롣
//ֵ͡=0:ｪλ  <0:顼
//СV1.0.0 2002/01/14 
/////////////////////////////////////////////////////////////////////////////
static INT InitFile(
struct ID_INFO *ps_ID, //(I)ID
FILE **pfp, //(I/O)
struct LOG_HEADER_INFO *ps_lghHdr //(I/O)
)
{
	*pfp = freopen( ps_ID->pszLogDir, "w", *pfp ); //ڤΤƾ񤭤ǳľ
	if ( !*pfp )
	{
		ps_ID->iErrNo = ERRNO_4210;
		return -1;
	}
//	setvbuf( *pfp, NULL, _IONBF, 0 );
	ps_lghHdr->dwLogCnt = 0; //ۺѤߥꥻå
	ps_lghHdr->bInit = 0; //ե饰ꥻå
	if ( WriteHeader( ps_ID, *pfp, ps_lghHdr ) < 0 ) //إå򹹿
		return -1;
	return 0;
}

/////////////////////////////////////////////////////////////////////////////
//ǽե롣
//ֵ͡=0:ｪλ  <0:顼
//СV1.0.0 2001/12/03 
/////////////////////////////////////////////////////////////////////////////
INT WINAPI TSLOG_Init(
CONST INT iID, //(I)ID >0
LPCTSTR pszLogDir, //(I)ե̾
CONST INT iSemKey //(I)ޥե
)
{
	TCHAR szExeDir[_MAX_PATH+1] = { 0 }, szLogDir[_MAX_PATH+1] = { 0 };
	TCHAR szDrv[_MAX_DRIVE+1] = { 0 }, szPath[_MAX_PATH+1] = { 0 };
	TCHAR szFile[_MAX_PATH+1] = { 0 };
	INT iNullDir = 0;
	FILE *fp = NULL;
	struct LOG_HEADER_INFO s_lghHdr; //¸եΥإå
	struct ID_INFO *ps_ID = NULL;

//
	memset( &s_lghHdr, 0, sizeof( s_lghHdr ));
//ᥤ
	ps_ID = GetIDInfo( iID, NULL ); //ID 
	if ( !ps_ID ) //ID ʤ
		return -1;
	if ( pszLogDir ) //ݥ󥿤ͭʤ
	{
		if ( strlen( pszLogDir )) //ϥե̾ꤵƤ
		{
			strcpy( szLogDir, pszLogDir ); //Mutex 
			ps_ID->pszLogDir = strdup( szLogDir );
		}
		else //ϥե̾ꤵƤʤʤ
			iNullDir = 1; //ʤ
	}
	else //ݥ󥿤̵ʤ
		iNullDir = 1; //ʤ
	if ( iNullDir ) //ϥե̾ꤵƤʤʤ
	{
#ifdef WIN32
		//DLL ƤӽФȤμ¹ԥե̾
		if ( !GetModuleFileName( NULL, szExeDir, sizeof( szExeDir )))
		{
			ps_ID->iErrNo = ERRNO_4208;
			return -1;
		}
		_splitpath( szExeDir, szDrv, szPath, szFile, NULL ); //ѥ
		_makepath( szLogDir, szDrv, szPath, szFile, ".log.txt" );
		ps_ID->pszLogDir = _mbsdup( szLogDir ); //szLogDir  Mutex 
#else //UNIX
		ps_ID->iErrNo = ERRNO_4209;
		return -1;
#endif
	}
#ifdef WIN32
	ConvertYen( szLogDir ); //ߥޡѴ Mutex ˻ѤǤʤ
	ps_ID->hMtx = CreateMutex( NULL, FALSE, szLogDir ); //ե Mutex 
	WaitForSingleObjectSafety( ps_ID->hMtx, INFINITE ); //å
#else //UNIX
	ps_ID->iSemKey = iSemKey;
	SemaphoreLock( ps_ID->iSemKey ); //å
#endif
	if ( OpenLog( ps_ID, &fp, &s_lghHdr ) < 0 ) //إåΤե򳫤
	{
#ifdef WIN32
		ReleaseMutexSafety( ps_ID->hMtx ); //å
#else //UNIX
		SemaphoreUnlock( ps_ID->iSemKey ); //å
#endif
		return -1;
	}
	if ( s_lghHdr.bOverWrit || s_lghHdr.bInit ) //⡼ɤʤ
	{
		if ( InitFile( ps_ID, &fp, &s_lghHdr ) < 0 ) //ե
		{
			fclose( fp );
#ifdef WIN32
			ReleaseMutexSafety( ps_ID->hMtx ); //å
#else //UNIX
			SemaphoreUnlock( ps_ID->iSemKey ); //å
#endif
			return -1;
		}
	}
	fclose( fp );
#ifdef WIN32
	ReleaseMutexSafety( ps_ID->hMtx ); //å
#else //UNIX
	SemaphoreUnlock( ps_ID->iSemKey ); //å
#endif
	return 0;
}

/////////////////////////////////////////////////////////////////////////////
//ǽե˽񤭹ࡣ
//⡧Ǥ¾򤻤̤ǹԤ
//ֵ͡=0:ｪλ  <0:顼
//СV1.0.0 2002/01/02 
/////////////////////////////////////////////////////////////////////////////
static INT WriteLogCore(
struct ID_INFO *ps_ID, //(I)ID
CONST INT iLvl, //(I)٥
CONST BOOL bWritTime, //(I)1:֤񤭹
LPCTSTR pszLog, ...
)
{
	TCHAR szLog[LOG_LENGTH_MAX] = { 0 }, szTmpLog[LOG_LENGTH_MAX] = { 0 };
	TCHAR szExtErrMsg[LOG_LENGTH_MAX] = { 0 };
	LPTSTR pszNext = NULL;
	LONG lFileOfst = 0;
	DWORD dwLogLen = 0;
	INT iOfst = 0;
	va_list vaArg;
	FILE *fp = NULL;
	struct LOG_HEADER_INFO s_lghHdr;
//ᥤ
	if ( OpenLog( ps_ID, &fp, &s_lghHdr ) < 0 ) //ե򳫤
		return -1;
	if ( s_lghHdr.bInit ) //ʤ
	{
		if ( InitFile( ps_ID, &fp, &s_lghHdr ) < 0 ) //ե
		{
			fclose( fp );
			return -1;
		}
	}
	if ( s_lghHdr.iLvl < iLvl ) //٥볰ʤ
	{
		fclose( fp );
		return 0; //⤷ʤ
	}
	va_start( vaArg, pszLog );
	vsprintf( szLog, pszLog, vaArg );
	va_end( vaArg );
	if ( s_lghHdr.bTime ) //ॹפʤ
	{
		if ( bWritTime ) //֤񤭹ʤ
		{
			time_t lTime;
			time( &lTime );
			strftime( szTmpLog, 16, "%m/%d %H:%M:%S ", localtime( &lTime ));
			strcat( szTmpLog, szLog );
		}
		else
			strcpy( szTmpLog, szLog );
		strcpy( szLog, szTmpLog ); //ɸ
	}
	if ( s_lghHdr.bStdOut )
		puts( szLog );
	pszNext = szLog;
	while ( 1 )
	{
		//ĹĴ
		INT iRet = MakeSameLength( ps_ID, &pszNext[iOfst], s_lghHdr.dwLogLen, s_lghHdr.cCRLF, szTmpLog );
		if ( iRet < 0 )
			return -1;
#ifdef WIN32
	#define CRLF_LENGTH 2
#else
	#define CRLF_LENGTH 1
#endif
		if ( s_lghHdr.dwLogCntMax <= s_lghHdr.dwLogCnt ) //ٺãƤ
		{
			lFileOfst = s_lghHdr.dwLogLen+CRLF_LENGTH; //1ܤ
			s_lghHdr.dwLogCnt = 0;
		}
		else
			lFileOfst = ( s_lghHdr.dwLogCnt+1 )*( s_lghHdr.dwLogLen+CRLF_LENGTH );
#undef CRLF_LENGTH
		fseek( fp, lFileOfst, SEEK_SET );
		fprintf( fp, "%s", szTmpLog );
		fflush( fp );
		s_lghHdr.dwLogCnt++;
		if ( WriteHeader( ps_ID, fp, &s_lghHdr ) < 0 )
			return -1;
		if ( s_lghHdr.bCut || !iRet ) //ԤƽϤ
			break;
		dwLogLen = s_lghHdr.dwLogLen; //ϤĹ
		if ( iRet == 2 ) //ХʸʬǤʤ褦Ƥ
			dwLogLen--;
		memset( &pszNext[iOfst], ' ', dwLogLen ); //ʬ򥹥ڡ
		iOfst += dwLogLen - (( s_lghHdr.bTime ) ? 15 : 0 );
	}
	fclose( fp );
	return 0;
}

/////////////////////////////////////////////////////////////////////////////
//ǽե˽񤭹ࡣ٥룱
//⡧٥룱礷ѰԹԲǽ
//ֵ͡=0:ｪλ  <0:顼
//СV1.0.0 2002/01/08 
/////////////////////////////////////////////////////////////////////////////
INT WINAPI TSLOG_Write(
CONST INT iID, //(I)ID >0
LPCTSTR pszLog, ...
)
{
	TCHAR szLog[LOG_LENGTH_MAX] = { 0 };
	struct ID_INFO *ps_ID = NULL;
	va_list vaArg;

//ᥤ
	ps_ID = GetIDInfo( iID, NULL );
	if ( !ps_ID )
		return miErrNo;
#ifdef WIN32
	WaitForSingleObjectSafety( ps_ID->hMtx, INFINITE ); //å
#else //UNIX
	SemaphoreLock( ps_ID->iSemKey ); //å
#endif
	va_start( vaArg, pszLog );
	vsprintf( szLog, pszLog, vaArg );
	va_end( vaArg );
	if ( WriteLogCore( ps_ID, 1, TRUE, szLog ) < 0 )
	{
#ifdef WIN32
		ReleaseMutexSafety( ps_ID->hMtx ); //å
#else
		SemaphoreUnlock( ps_ID->iSemKey ); //å
#endif
		return -1;
	}
#ifdef WIN32
	ReleaseMutexSafety( ps_ID->hMtx ); //å
#else
	SemaphoreUnlock( ps_ID->iSemKey ); //å
#endif
	return 0;
}

/////////////////////////////////////////////////////////////////////////////
//ǽե˽񤭹ࡣ٥룲
//⡧٥룱礷ѰԹԲǽ
//ֵ͡=0:ｪλ  <0:顼
//СV1.0.0 2002/01/08 
/////////////////////////////////////////////////////////////////////////////
INT WINAPI TSLOG_Write2(
CONST INT iID, //(I)ID >0
LPCTSTR pszLog, ...
)
{
	TCHAR szLog[LOG_LENGTH_MAX] = { 0 };
	struct ID_INFO *ps_ID = NULL;
	va_list vaArg;

//ᥤ
	ps_ID = GetIDInfo( iID, NULL );
	if ( !ps_ID )
		return miErrNo;
#ifdef WIN32
	WaitForSingleObjectSafety( ps_ID->hMtx, INFINITE ); //å
#else //UNIX
	SemaphoreLock( ps_ID->iSemKey ); //å
#endif
	va_start( vaArg, pszLog );
	vsprintf( szLog, pszLog, vaArg );
	va_end( vaArg );
	if ( WriteLogCore( ps_ID, 2, TRUE, szLog ) < 0 )
	{
#ifdef WIN32
		ReleaseMutexSafety( ps_ID->hMtx ); //å
#else
		SemaphoreUnlock( ps_ID->iSemKey ); //å
#endif
		return -1;
	}
#ifdef WIN32
	ReleaseMutexSafety( ps_ID->hMtx ); //å
#else
	SemaphoreUnlock( ps_ID->iSemKey ); //å
#endif
	return 0;
}

/////////////////////////////////////////////////////////////////////////////
//ǽե˽񤭹ࡣ٥룳
//⡧٥룱礷ѰԹԲǽ
//ֵ͡=0:ｪλ  <0:顼
//СV1.0.0 2002/01/08 
/////////////////////////////////////////////////////////////////////////////
INT WINAPI TSLOG_Write3(
CONST INT iID, //(I)ID >0
LPCTSTR pszLog, ...
)
{
	TCHAR szLog[LOG_LENGTH_MAX] = { 0 };
	struct ID_INFO *ps_ID = NULL;
	va_list vaArg;

//ᥤ
	ps_ID = GetIDInfo( iID, NULL );
	if ( !ps_ID )
		return miErrNo;
#ifdef WIN32
	WaitForSingleObjectSafety( ps_ID->hMtx, INFINITE ); //å
#else //UNIX
	SemaphoreLock( ps_ID->iSemKey ); //å
#endif
	va_start( vaArg, pszLog );
	vsprintf( szLog, pszLog, vaArg );
	va_end( vaArg );
	if ( WriteLogCore( ps_ID, 3, TRUE, szLog ) < 0 )
	{
#ifdef WIN32
		ReleaseMutexSafety( ps_ID->hMtx ); //å
#else
		SemaphoreUnlock( ps_ID->iSemKey ); //å
#endif
		return -1;
	}
#ifdef WIN32
	ReleaseMutexSafety( ps_ID->hMtx ); //å
#else
	SemaphoreUnlock( ps_ID->iSemKey ); //å
#endif
	return 0;
}

//////////////////////////////////////////////////////////////////////
//ǽե˽񤭹ࡣ
//ֵ͡=0:ｪλ  <0:顼
//СV1.0.0 2002/01/08 
//////////////////////////////////////////////////////////////////////
INT WINAPI TSLOG_WriteHex(
CONST INT iID, //(I)ID >0
CONST VOID* pvLog, //ʤ LPVOID 顼ˤʤ
CONST DWORD dwLogLen,
LPCTSTR pszMsg, ...
)
{
	TCHAR szMsg[LOG_LENGTH_MAX] = { 0 }, szLog[80] = { 0 }, szChr[80] = { 0 };
	LPBYTE pbyLog = NULL, pbyLead = NULL;
	BYTE byLead = 0;
	INT i, j;
	INT iIdx = 0, iLineCnt = 0;
	struct LOG_HEADER_INFO s_lghHdr;
	struct ID_INFO *ps_ID = NULL;
	FILE *fp = NULL;
	va_list vaArg;

//
	memset( &s_lghHdr, 0, sizeof( s_lghHdr ));
//ᥤ
	ps_ID = GetIDInfo( iID, NULL );
	if ( !ps_ID )
		return miErrNo;
#ifdef WIN32
	WaitForSingleObjectSafety( ps_ID->hMtx, INFINITE ); //å
#else
	SemaphoreLock( ps_ID->iSemKey ); //å
#endif
	pbyLog = (LPBYTE)pvLog;
	if ( OpenLog( ps_ID, &fp, &s_lghHdr ) < 0 ) //إåΤե򳫤
	{
#ifdef WIN32
		ReleaseMutexSafety( ps_ID->hMtx ); //å
#else
		SemaphoreUnlock( ps_ID->iSemKey ); //å
#endif
		return -1;
	}
	fclose( fp );
	if ( !s_lghHdr.bHex ) //hexϤʤʤ
	{
#ifdef WIN32
		ReleaseMutexSafety( ps_ID->hMtx ); //å
#else
		SemaphoreUnlock( ps_ID->iSemKey ); //å
#endif
		return 0; //ｪλ
	}
	va_start( vaArg, pszMsg );
	vsprintf( szMsg, pszMsg, vaArg );
	va_end( vaArg );
	if ( WriteLogCore( ps_ID, 0, TRUE, szMsg ) < 0 ) //å
	{
#ifdef WIN32
		ReleaseMutexSafety( ps_ID->hMtx ); //å
#else
		SemaphoreUnlock( ps_ID->iSemKey ); //å
#endif
		return -1;
	}
//	if ( WriteLogCore( ps_ID, 0, FALSE, "ADDRESS |+0 +1 +2 +3 +4 +5 +6 +7|+8 +9 +A +B +C +D +E +F|0123456789ABCDEF" ) < 0 )
	if ( WriteLogCore( ps_ID, 0, FALSE, "BASE %08X|+0 +1 +2 +3 +4 +5 +6 +7|+8 +9 +A +B +C +D +E +F|0123456789ABCDEF", (DWORD)pvLog ) < 0 )
	{
#ifdef WIN32
		ReleaseMutexSafety( ps_ID->hMtx ); //å
#else
		SemaphoreUnlock( ps_ID->iSemKey ); //å
#endif
		return -1;
	}
	iLineCnt = ((INT)dwLogLen-1 )/16+1;
	for ( i = 0 ; i < iLineCnt ; i++ )
	{
		sprintf( szLog, "     %08X|", i*16 ); //ɥ쥹
		for ( j = 0 ; j < 16 ; j++ )
		{
			if ((DWORD)i*16+j < dwLogLen )
				sprintf( szChr, "%02X ", pbyLog[i*16+j] );
			else
				strcpy( szChr, "   " );
			strcat( szLog, szChr );
			if ( j == 7 || j == 15 )
				szLog[strlen( szLog )-1] = '|'; //ѥ졼
		}
		byLead = '\0'; //ԥХȤ򥯥ꥢ
		for ( j = 0 ; j < 16 ; j++ )
		{
			iIdx = i*16+j;
			if ((DWORD)iIdx < dwLogLen )
			{
				if ( byLead ) //ԥХȤ¸Ƥ
				{
					sprintf( szChr, "%c%c", byLead, pbyLog[iIdx] );
					strcat( szLog, szChr );			
					byLead = '\0'; //ԥХȤ򥯥ꥢ
				}
				else //ԥХȤ¸Ƥʤʤ
				{
					if ( !pbyLead ) //ȯܤʤ
						pbyLead = pbyLog; //ƬԥХȤȤ
					//ԥХȤǡ³ǡʤ
					if ( ISMBSLEAD( pbyLead, pbyLog+iIdx ) == -1 && (DWORD)iIdx+1 < dwLogLen )
					{
						pbyLead = pbyLog+iIdx; //ԥХȰ֤Ȥ¸
						byLead = *pbyLead; //ԥХȤ¸
					}
					else //ԥХȤǤʤʤ
					{
#ifdef WIN32
						if ( isprint( pbyLog[iIdx] ) //ɽǽʸȾѥʤʤ
							|| ((unsigned)0xA1 <= pbyLog[iIdx] && pbyLog[iIdx] <= (unsigned)0xDF ))
#else //UNIX
						if ( isprint( pbyLog[iIdx] )) //ɽǽʸʤ
#endif
						{
							pbyLead = pbyLog+iIdx; //ԥХȰ֤Ȥ¸
							sprintf( szChr, "%c", *pbyLead );
							strcat( szLog, szChr );
						}
						else //ɽԲǽʸʤ
						{
							strcat( szLog, "." );
							byLead = '\0'; //ԥХȤ򥯥ꥢ
							if ( pbyLog[iIdx] == '\0' ) // NULL ä
								pbyLead = pbyLog+iIdx+1; //˼ԥХȤȤ
						}
					}
				}
			}
			else
				strcat( szLog, " " );
		}
		if ( byLead ) //ԥХȤǽäƤ
		{
			if ((DWORD)iIdx+1 < dwLogLen ) //³ǡʤ
			{
				sprintf( szChr, "%c%c", byLead, pbyLog[iIdx+1] );
				strcat( szLog, szChr );			
			}
		}
		if ( WriteLogCore( ps_ID, 0, FALSE, szLog ) < 0 )
		{
#ifdef WIN32
			ReleaseMutexSafety( ps_ID->hMtx ); //å
#else
			SemaphoreUnlock( ps_ID->iSemKey ); //å
#endif
			return -1;
		}
	}
#ifdef WIN32
	ReleaseMutexSafety( ps_ID->hMtx ); //å
#else
	SemaphoreUnlock( ps_ID->iSemKey ); //å
#endif
	return 0;
}

///////////////////////////////////////////////////////////////////////////////
//ǽID롣
//ֵ͡=0:ｪλ  <0:顼
//СV1.0.0 2002/01/08 
///////////////////////////////////////////////////////////////////////////////
INT WINAPI TSLOG_FreeID(
CONST INT iID //(I)ID >0
)
{
	struct ID_INFO *ps_IDTmp = NULL, *ps_IDPrev = NULL;
#ifdef WIN32
	HANDLE hMtx = CreateMutex( NULL, FALSE, mszMtx );
	WaitForSingleObjectSafety( hMtx, INFINITE ); //å
#endif
	ps_IDTmp = GetIDInfo( iID, &ps_IDPrev );
	if ( !ps_IDTmp ) //IDĤʤä
	{
#ifdef WIN32
		ReleaseMutexSafety( hMtx ); //å
#endif
		return -1;
	}
	ps_IDPrev->ps_IDNext = ps_IDTmp->ps_IDNext; //ꥹȤĤʤľ
	free( ps_IDTmp->pszLogDir );
	TSCSV_FreeID( ps_IDTmp->iCSV_Item );
	TSCSV_FreeID( ps_IDTmp->iCSV_Val );
#ifdef WIN32
	ReleaseMutexSafety( ps_IDTmp->hMtx );
#endif
	free( ps_IDTmp );
#ifdef WIN32
	ReleaseMutexSafety( hMtx ); //å
#endif
	return 0;
}

///////////////////////////////////////////////////////////////////////////////
//ǽ顼ɤ֤
//ֵ͡>0:顼  <0:顼
//СV1.0.0 2001/11/03 
///////////////////////////////////////////////////////////////////////////////
INT WINAPI TSLOG_GetErrorNo(
CONST INT iID //(I)ID >0
)
{
	struct ID_INFO *ps_ID = NULL;

	if ( iID <= 0 )
		return miErrNo;
	ps_ID = GetIDInfo( iID, NULL );
	if ( !ps_ID )
		return miErrNo;
	return ps_ID->iErrNo;
}

/////////////////////////////////////////////////////////////////////////////
//ǽե˽񤭹ࡣ٥룱VB ѡ
//ֵ͡=0:ｪλ  <0:顼
//СV1.0.0 2002/01/25 
/////////////////////////////////////////////////////////////////////////////
INT WINAPI TSLOG_WriteVB(
CONST INT iID, //(I)ID >0
LPCTSTR pszLog
)
{
	return TSLOG_Write( iID, pszLog );
}

/////////////////////////////////////////////////////////////////////////////
//ǽե˽񤭹ࡣ٥룲VB ѡ
//ֵ͡=0:ｪλ  <0:顼
//СV1.0.0 2002/01/25 
/////////////////////////////////////////////////////////////////////////////
INT WINAPI TSLOG_WriteVB2(
CONST INT iID, //(I)ID >0
LPCTSTR pszLog
)
{
	return TSLOG_Write2( iID, pszLog );
}

/////////////////////////////////////////////////////////////////////////////
//ǽե˽񤭹ࡣ٥룳VB ѡ
//ֵ͡=0:ｪλ  <0:顼
//СV1.0.0 2002/01/25 
/////////////////////////////////////////////////////////////////////////////
INT WINAPI TSLOG_WriteVB3(
CONST INT iID, //(I)ID >0
LPCTSTR pszLog
)
{
	return TSLOG_Write3( iID, pszLog );
}

/////////////////////////////////////////////////////////////////////////////
//ǽե˽񤭹ࡣVB ѡ
//ֵ͡=0:ｪλ  <0:顼
//СV1.0.0 2002/01/25 
/////////////////////////////////////////////////////////////////////////////
INT WINAPI TSLOG_WriteHexVB(
CONST INT iID, //(I)ID >0
CONST VOID* pvLog, //ʤ LPVOID 顼ˤʤ
CONST DWORD dwLogLen,
LPCTSTR pszMsg
)
{
	return TSLOG_WriteHex( iID, pvLog, dwLogLen, pszMsg );
}

